// Code generated by "enumer -type=GitStatus -json -text -yaml -sql"; DO NOT EDIT.

//
package gitStatuses

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _GitStatusName = "UnknownAlreadyUpToDateCleanNonFastForwardRemoteEmptySuccessUnstagedChanges"

var _GitStatusIndex = [...]uint8{0, 7, 22, 27, 41, 52, 59, 74}

func (i GitStatus) String() string {
	if i < 0 || i >= GitStatus(len(_GitStatusIndex)-1) {
		return fmt.Sprintf("GitStatus(%d)", i)
	}
	return _GitStatusName[_GitStatusIndex[i]:_GitStatusIndex[i+1]]
}

var _GitStatusValues = []GitStatus{0, 1, 2, 3, 4, 5, 6}

var _GitStatusNameToValueMap = map[string]GitStatus{
	_GitStatusName[0:7]:   0,
	_GitStatusName[7:22]:  1,
	_GitStatusName[22:27]: 2,
	_GitStatusName[27:41]: 3,
	_GitStatusName[41:52]: 4,
	_GitStatusName[52:59]: 5,
	_GitStatusName[59:74]: 6,
}

// GitStatusString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func GitStatusString(s string) (GitStatus, error) {
	if val, ok := _GitStatusNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to GitStatus values", s)
}

// GitStatusValues returns all values of the enum
func GitStatusValues() []GitStatus {
	return _GitStatusValues
}

// IsAGitStatus returns "true" if the value is listed in the enum definition. "false" otherwise
func (i GitStatus) IsAGitStatus() bool {
	for _, v := range _GitStatusValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for GitStatus
func (i GitStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for GitStatus
func (i *GitStatus) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("GitStatus should be a string, got %s", data)
	}

	var err error
	*i, err = GitStatusString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for GitStatus
func (i GitStatus) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for GitStatus
func (i *GitStatus) UnmarshalText(text []byte) error {
	var err error
	*i, err = GitStatusString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for GitStatus
func (i GitStatus) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for GitStatus
func (i *GitStatus) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = GitStatusString(s)
	return err
}

func (i GitStatus) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *GitStatus) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := GitStatusString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
